import mark from './core';
import { setConfig, remove, removeAll, renderAll, query } from './localManager';
var DOMContentLoaded = new Promise(function (resolve) {
  window.addEventListener('load', function () {
    var styleElement = document.createElement('style');
    styleElement.innerHTML = ".qoxop_highlight {background: #f3f308;}";
    document.head.appendChild(styleElement);
    setTimeout(function () {
      resolve();
    }, 10);
  });
});

function init() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var config = setConfig(options);
  var pageId = config.pageHash(window.location.href);
  var immediate = options.immediate,
      onUrlChange = options.onUrlChange,
      _options$delay = options.delay,
      delay = _options$delay === void 0 ? 500 : _options$delay;
  var cancelKey = 0;

  if (immediate) {
    DOMContentLoaded.then(renderAll);
  }

  if (onUrlChange) {
    var observer = new MutationObserver(function () {
      if (cancelKey !== 0) {
        clearTimeout(cancelKey);
      } // @ts-ignore


      cancelKey = setTimeout(function () {
        cancelKey = 0;
        var newPageId = config.pageHash(window.location.href);

        if (pageId !== newPageId) {
          pageId = newPageId;
          renderAll();
        }
      }, delay);
    });
    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
  }
}

export { init, mark, remove, setConfig, removeAll, renderAll, query };