import { MarkInfo } from './types';
interface Config {
    pageHash?: (href: string) => string;
    pageHashPrefix?: string;
    getPageInfo?: () => any;
    markTagName?: string;
    defaultClassName?: string;
    [key: string]: any;
}
interface Store {
    [PrefixPageHash: string]: {
        marks: MarkInfo[];
        pageInfo: any;
    };
}
/**
 * 设置配置项
 * @param options
 */
declare function setConfig(options?: Config): Config;
/**
 * 渲染当前页的所有标记
 */
declare function renderAll(): boolean;
/**
 * 移除标记
 * @param id
 * @param allRmHandler
 */
declare function remove(id: string, allRmHandler?: (clear: Function, marks: MarkInfo[]) => void): void;
interface TextSet {
    [key: string]: string[];
}
/**
 * 标记文本查询
 */
declare const query: {
    marks(): Store;
    texts(includeHistory?: boolean): TextSet;
};
interface RemoveAllOpt {
    domain?: boolean;
    retainTexts?: boolean;
}
/**
 * 清除所有标记
 * @param params
 */
declare function removeAll(options?: RemoveAllOpt): void;
export { Config, remove, setConfig, removeAll, renderAll, query };
