"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.init = init;
Object.defineProperty(exports, "mark", {
  enumerable: true,
  get: function get() {
    return _core["default"];
  }
});
Object.defineProperty(exports, "setConfig", {
  enumerable: true,
  get: function get() {
    return _localManager.setConfig;
  }
});
Object.defineProperty(exports, "remove", {
  enumerable: true,
  get: function get() {
    return _localManager.remove;
  }
});
Object.defineProperty(exports, "removeAll", {
  enumerable: true,
  get: function get() {
    return _localManager.removeAll;
  }
});
Object.defineProperty(exports, "renderAll", {
  enumerable: true,
  get: function get() {
    return _localManager.renderAll;
  }
});
Object.defineProperty(exports, "query", {
  enumerable: true,
  get: function get() {
    return _localManager.query;
  }
});

var _core = _interopRequireDefault(require("./core"));

var _localManager = require("./localManager");

var DOMContentLoaded = new Promise(function (resolve) {
  window.addEventListener('load', function () {
    var styleElement = document.createElement('style');
    styleElement.innerHTML = ".qoxop_highlight {background: #f3f308;}";
    document.head.appendChild(styleElement);
    setTimeout(function () {
      resolve();
    }, 10);
  });
});

function init() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var config = (0, _localManager.setConfig)(options);
  var pageId = config.pageHash(window.location.href);
  var immediate = options.immediate,
      onUrlChange = options.onUrlChange,
      _options$delay = options.delay,
      delay = _options$delay === void 0 ? 500 : _options$delay;
  var cancelKey = 0;

  if (immediate) {
    DOMContentLoaded.then(_localManager.renderAll);
  }

  if (onUrlChange) {
    var observer = new MutationObserver(function () {
      if (cancelKey !== 0) {
        clearTimeout(cancelKey);
      } // @ts-ignore


      cancelKey = setTimeout(function () {
        cancelKey = 0;
        var newPageId = config.pageHash(window.location.href);

        if (pageId !== newPageId) {
          pageId = newPageId;
          (0, _localManager.renderAll)();
        }
      }, delay);
    });
    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
  }
}